%define major		11
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

Summary:	Tools for manipulating graphics files in netpbm supported formats
Name:		netpbm
Version:	10.87.01
%define subrel 1
Release:	%mkrel 3
License:	GPL Artistic MIT
Group:		Graphics/Utilities
URL:		http://netpbm.sourceforge.net/
# Source0 is prepared by
# svn export https://svn.code.sourceforge.net/p/netpbm/code/advanced netpbm-%%{version}
# svn export https://svn.code.sourceforge.net/p/netpbm/code/userguide netpbm-%%{version}/userguide
# and removing the ppmtompeg code, due to patents ( rm -rf netpbm-%%{version}/converter/ppm/ppmtompeg/ )
# Memo: tar Jcvf netpbm-%%{version}.tar.xz netpbm-%%{version}/
Source0:	netpbm-%{version}.tar.xz
Source1:	mf50-netpbm_filters
Source2:	test-images.tar.bz2
Patch1:		netpbm-time.patch
Patch2:		netpbm-message.patch
Patch3:		netpbm-security-scripts.patch
Patch4:		netpbm-security-code.patch
Patch5:		netpbm-CVE-2017-2587.patch
Patch6:		netpbm-gcc4.patch
Patch7:		netpbm-bmptopnm.patch
Patch8:		netpbm-CAN-2005-2471.patch
Patch9:		netpbm-xwdfix.patch
Patch10:	netpbm-python3.patch
Patch11:	netpbm-multilib.patch
Patch13:	netpbm-glibc.patch
Patch15:	netpbm-docfix.patch
Patch16:	netpbm-ppmfadeusage.patch
Patch17:	netpbm-fiasco-overflow.patch
Patch20:	netpbm-noppmtompeg.patch
Patch21:	netpbm-cmuwtopbm.patch
Patch22:	netpbm-pamtojpeg2k.patch
Patch23:	netpbm-manfix.patch
Patch24:	netpbm-ppmtopict.patch
Patch26:	netpbm-werror.patch
Patch27:	netpbm-disable-pbmtog3.patch
Patch28:	netpbm-pnmtops.patch
Patch29:	netpbm-config.patch
BuildRequires:	flex
BuildRequires:	pkgconfig(jasper)
BuildRequires:	jbig-devel
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	ghostscript
BuildRequires:	pkgconfig(libpng16)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	python3
BuildRequires:	pkgconfig(python3)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(x11)
BuildConflicts:	svgalib-devel

%description
The netpbm package contains a library of functions which support programs for
handling various graphics file formats, including .pbm (portable bitmaps), .pgm
(portable graymaps), .pnm (portable anymaps), .ppm (portable pixmaps) and
others.

%package -n	%{libname}
Summary:        A library for handling different graphics file formats
Group:          System/Libraries

%description -n	%{libname}
The netpbm package contains a library of functions which support programs for
handling various graphics file formats, including .pbm (portable bitmaps), .pgm
(portable graymaps), .pnm (portable anymaps), .ppm (portable pixmaps) and
others.

%package -n	%{develname}
Summary:	Development tools for programs which will use the netpbm libraries
Group:		Development/C
Requires:	%{libname} >= %{version}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	netpbm-devel = %{version}-%{release}
Obsoletes:	%{mklibname netpbm 10 -d}

%description -n	%{develname}
The %{develname} package contains the header files and programmer's
documentation for developing programs which can handle the various graphics
file formats supported by the netpbm libraries.

Install %{develname} if you want to develop programs for handling the graphics
file formats supported by the netpbm libraries. You'll also need to have the
netpbm package installed.


%prep
%setup -q -a2

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

%patch1 -p1 -b .time
%patch2 -p1 -b .message
%patch3 -p1 -b .security-scripts
%patch4 -p1 -b .security-code
%patch5 -p1 -b .CVE-2017-2587
%patch6 -p1 -b .gcc4
%patch7 -p1 -b .bmptopnm
%patch8 -p1 -b .CAN-2005-2471
%patch9 -p1 -b .xwdfix
%patch10 -p1 -b .python3
%patch11 -p1 -b .multilib
%patch13 -p1 -b .glibc
%patch15 -p1 -b .docfix
%patch16 -p1 -b .ppmfadeusage
%patch17 -p1 -b .fiasco-overflow
%patch20 -p1 -b .noppmtompeg
%patch21 -p1 -b .cmuwtopbmfix
%patch22 -p1 -b .pamtojpeg2kfix
%patch23 -p1 -b .manfix
%patch24 -p1 -b .ppmtopict
%patch26 -p1 -b .werror
%patch27 -p1 -b .disable-pbmtog3
%patch28 -p1 -b .pnmtops
%patch29 -p1 -b .config

sed -i 's/PNGVER = .*/PNGVER = 16/g' config.mk.in

rm -rf converter/other/jpeg2000/libjasper/
rm -rf converter/other/jbig/libjbig/

rm -f userguide/pammixmulti.html

%build
%serverbuild
#export CFLAGS="$CFLAGS -fPIC -flax-vector-conversions -fno-strict-aliasing"

./configure <<EOF



















EOF

TOP=`pwd`
make \
    CC="%{__cc}" \
    CFLAGS_PERSONAL="$CFLAGS"
    LDFLAGS="-L$TOP/pbm -L$TOP/pgm -L$TOP/pnm -L$TOP/ppm %{ldflags}" \
    CFLAGS_SHLIB="-fPIC" \
    MATHLIB="-lm" \
    TIFFLIB_DIR=%{_libdir} TIFFLIB=-ltiff TIFFINC_DIR=%{_includedir} TIFFHDR_DIR=%{_includedir} \
    JPEGLIB_DIR=%{_libdir} JPEGLIB=-ljpeg JPEGHDR_DIR=%{_includedir} JPEGINC_DIR=%{_includedir} \
    PNGLIB_DIR=%{_libdir} PNGLIB="-L%{_libdir} -lpng16" PNGINC_DIR=%{_includedir}/libpng16 PNGHDR_DIR=%{_includedir}/libpng16 \
    ZLIB_DIR=%{_libdir} ZLIB="-L%{_libdir} -lz" ZHDR_DIR=%{_includedir} \
    X11LIB_DIR=%{_libdir} X11LIB="-L%{_libdir} -lX11" X11INC_DIR=%{_includedir} X11HDR_DIR=%{_includedir} \
    JBIGLIB_DIR=%{_libdir} JBIGLIB="-L%{_libdir} -ljbig" JBIGHDR_DIR=%{_includedir} \
    XML2LIBS="NONE" LINUXSVGALIB="NONE"

# prepare man files
cd userguide
rm -f ppmtompeg*
rm -f *.manual-pages
rm -f *.manfix
for i in *.html ; do
    ../buildtools/makeman ${i}
done
for i in 1 3 5 ; do
    mkdir -p man/man${i}
    mv *.${i} man/man${i}
done

%install
install -d %{buildroot}
make package PKGDIR=%{buildroot}%{_prefix} XML2LIBS="NONE" LINUXSVGALIB="NONE"

# Ugly hack to have libs in correct dir on 64bit archs.
install -d %{buildroot}%{_libdir}
if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    mv %{buildroot}%{_prefix}/lib/lib* %{buildroot}%{_libdir}
fi

install -m0644 lib/libnetpbm.a %{buildroot}%{_libdir}/libnetpbm.a
ln -sf libnetpbm.so.%{major} %{buildroot}%{_libdir}/libnetpbm.so

# fix manpages
install -d %{buildroot}%{_mandir}
cp -rp userguide/man/* %{buildroot}%{_mandir}/

# Get rid of the useless non-ascii character in pgmminkowski.1
sed -i 's/\xa0//' %{buildroot}%{_mandir}/man1/pgmminkowski.1

# Don't ship man pages for non-existent binaries and bogus ones
for i in hpcdtoppm pcdovtoppm pnmtojbig ppmsvgalib vidtoppm picttoppm jbigtopnm \
    directory error extendedopacity pam pbm pgm pnm ppm index libnetpbm_dir liberror \
    pambackground pamfixtrunc pamtogif pamtooctaveimg pamundice ppmtotga; do
    rm -f %{buildroot}%{_mandir}/man1/${i}.1
done
rm -f %{buildroot}%{_mandir}/man5/extendedopacity.5

install -d %{buildroot}%{_datadir}/%{name}-%{version}
mv %{buildroot}%{_prefix}/misc/*.map %{buildroot}%{_datadir}/%{name}-%{version}
rm -rf %{buildroot}%{_prefix}/README
rm -rf %{buildroot}%{_prefix}/VERSION
rm -rf %{buildroot}%{_prefix}/link
rm -rf %{buildroot}%{_prefix}/misc
rm -rf %{buildroot}%{_prefix}/man
rm -rf %{buildroot}%{_prefix}/pkginfo
rm -rf %{buildroot}%{_prefix}/config_template
rm -rf %{buildroot}%{_prefix}/pkgconfig_template
rm -f %{buildroot}%{_mandir}/man1/ppmtompeg.1*

install -d %{buildroot}%{_datadir}/printconf/mf_rules
cp %{SOURCE1} %{buildroot}%{_datadir}/printconf/mf_rules/

install -d %{buildroot}%{_datadir}/printconf/tests
cp test-images/* %{buildroot}%{_datadir}/printconf/tests/

%multiarch_includes %{buildroot}%{_includedir}/netpbm/pm_config.h

# Don't ship the static library
find %{buildroot} -name '*.a' -delete

# remove/symlink/substitute obsolete utilities
pushd %{buildroot}%{_bindir}
rm -f pgmtopbm pnmcomp
ln -s pamcomp pnmcomp
echo -e '#!/bin/sh\npamditherbw $@ | pamtopnm\n' > pgmtopbm
chmod 0755 pgmtopbm
popd

rm -rf %{buildroot}%{_prefix}/{sharedlink,staticlink}


%check
pushd test
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
export PBM_TESTPREFIX=%{buildroot}%{_bindir}
export PBM_BINPREFIX=%{buildroot}%{_bindir}
./Execute-Tests && exit 0
popd

%files
%{_bindir}/*
%{_datadir}/%{name}-%{version}
%dir %{_datadir}/printconf
%dir %{_datadir}/printconf/mf_rules
%dir %{_datadir}/printconf/tests
%{_datadir}/printconf/mf_rules/*
%{_datadir}/printconf/tests/*
%{_mandir}/man[15]/*

%files -n %{libname}
%doc doc/*
%{_libdir}/lib*.so.%{major}{,.*}

%files -n %{develname}
%dir %{_includedir}/netpbm
%{_includedir}/netpbm/*.h
%{multiarch_includedir}/netpbm/pm_config.h
%{_libdir}/lib*.so
%{_mandir}/man3/*


%changelog
* Wed Nov 30 2022 ns80 <ns80> 10.87.01-3.1.mga8
+ Revision: 1913291
- rebuild for new jbigkit (mga#31189)

* Sun Feb 16 2020 umeabot <umeabot> 10.87.01-3.mga8
+ Revision: 1530589
- Mageia 8 Mass Rebuild

* Tue Sep 03 2019 daviddavid <daviddavid> 10.87.01-2.mga8
+ Revision: 1436664
- port to Python 3

* Fri Aug 30 2019 daviddavid <daviddavid> 10.87.01-1.mga8
+ Revision: 1435359
- new version: 10.87.01

* Sat Apr 13 2019 daviddavid <daviddavid> 10.86.02-1.mga7
+ Revision: 1389743
- new version: 10.86.02
- rediff CAN-2005-2471 patch

* Thu Feb 07 2019 daviddavid <daviddavid> 10.85.01-1.mga7
+ Revision: 1364038
- new version: 10.85.01
- rediff some patches

* Sun Nov 25 2018 daviddavid <daviddavid> 10.84.03-1.mga7
+ Revision: 1333990
- new version: 10.84.03
- use system libjbig
- rediff some patches

* Sun Sep 23 2018 umeabot <umeabot> 10.73.18-3.mga7
+ Revision: 1299713
- Mageia 7 Mass Rebuild

* Mon Apr 16 2018 daviddavid <daviddavid> 10.73.18-2.mga7
+ Revision: 1219291
- rebuild for new jasper 2.0.14

* Fri Apr 13 2018 kekepower <kekepower> 10.73.18-1.mga7
+ Revision: 1218104
- Update to version 10.73.18

* Sun Sep 17 2017 cjw <cjw> 10.73.07-2.mga7
+ Revision: 1154874
- pass cflags to make to fix debug packages
- disable cflags additions for now since they have apparently never been tested

* Wed Feb 08 2017 mrambo3501 <mrambo3501> 10.73.07-1.mga6
+ Revision: 1085127
- 10.73.07 fixes CVE-2017-2579 and CVE-2017-258[0167]
- modify netpbm-security-code.patch to apply

* Sat Jan 02 2016 luigiwalser <luigiwalser> 10.71.02-1.mga6
+ Revision: 918505
- add patch to fix silly compiler errors
- 10.71.02 (sync with fedora)

* Tue May 19 2015 luigiwalser <luigiwalser> 10.61.02-5.mga5
+ Revision: 822395
- adapt patch from dcraw to fix CVE-2015-3885

* Wed Oct 15 2014 umeabot <umeabot> 10.61.02-4.mga5
+ Revision: 745534
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 10.61.02-3.mga5
+ Revision: 727474
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 10.61.02-2.mga5
+ Revision: 682854
- Mageia 5 Mass Rebuild

* Sat Mar 08 2014 spuhler <spuhler> 10.61.02-1.mga5
+ Revision: 601096
- upgrade to ver. 10.61.02
- synched spec with Fedora
 * added patches
 * added test section
- removed static libs

* Wed Mar 05 2014 spuhler <spuhler> 10.57.01-5.mga5
+ Revision: 600268
- fix building with libpng16

* Sun Feb 16 2014 tv <tv> 10.57.01-4.mga5
+ Revision: 592701
- fix building with libpng16
- build with libpng16

* Fri Oct 18 2013 umeabot <umeabot> 10.57.01-3.mga4
+ Revision: 521247
- Mageia 4 Mass Rebuild

* Sat Jan 19 2013 fwang <fwang> 10.57.01-2.mga3
+ Revision: 389753
- update rpm group
+ umeabot <umeabot>
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Mar 03 2012 luigiwalser <luigiwalser> 10.57.01-1.mga2
+ Revision: 217638
- 10.57.01 (sync with mdv)
- 10.57.01 (sync with mdv)

* Sat Jan 28 2012 fwang <fwang> 10.47.35-2.mga2
+ Revision: 202632
- force use png12

* Sat Jan 28 2012 fwang <fwang> 10.47.35-1.mga2
+ Revision: 202625
- new verison 10.47.35

* Sun Dec 25 2011 fwang <fwang> 10.47.29-3.mga2
+ Revision: 187435
- force use of png12
- br png12
- rebuild for new tiff
- rebuild for new libpng

* Fri Sep 09 2011 tv <tv> 10.47.29-1.mga2
+ Revision: 141799
- new release
- man fix patch from FC
- multiarch fix

* Thu Jan 13 2011 ahmad <ahmad> 10.47.21-2.mga1
+ Revision: 8862
- drop old/unneeded scriptlets
- imported package netpbm


* Tue Dec 21 2010 Oden Eriksson <oeriksson@mandriva.com> 10.47.21-1mdv2011.0
+ Revision: 623736
- 10.47.21 (sync slightly with fedora)
- remove the ppmtompeg man page too. ppmtompeg was removed due to licensing issues

* Tue Oct 12 2010 Oden Eriksson <oeriksson@mandriva.com> 10.47.20-1mdv2011.0
+ Revision: 585187
- more format string fixes
- rediffed one patch
- sync with fedora

* Mon Aug 09 2010 Oden Eriksson <oeriksson@mandriva.com> 10.47.17-1mdv2011.0
+ Revision: 568120
- sync with netpbm-10.47.17-1.fc14.src.rpm

* Sun Jan 31 2010 Oden Eriksson <oeriksson@mandriva.com> 10.47.09-1mdv2010.1
+ Revision: 498807
- really sync it
- sync with netpbm-10.47.09-2.fc13.src.rpm

* Mon Jan 11 2010 Funda Wang <fwang@mandriva.org> 10.47.07-2mdv2010.1
+ Revision: 489538
- rebuild for libjpeg v8

  + Oden Eriksson <oeriksson@mandriva.com>
    - 10.47.07

* Sat Dec 19 2009 Oden Eriksson <oeriksson@mandriva.com> 10.47.06-1mdv2010.1
+ Revision: 480135
- sync with netpbm-10.47.06-1.fc13.src.rpm

* Mon Nov 09 2009 Oden Eriksson <oeriksson@mandriva.com> 10.47.04-1mdv2010.1
+ Revision: 463436
- sync with netpbm-10.47.04-1.fc12.src.rpm
- rediffed the format string patch
- dropped the jpeg-7 patch, it was implemented upstream

* Sun Sep 27 2009 Olivier Blin <oblin@mandriva.com> 10.35.64-4mdv2010.0
+ Revision: 450162
- buildrequire libx11-devel instead of full X11-devel
  (from Arnaud Patard)

* Sat Aug 15 2009 Oden Eriksson <oeriksson@mandriva.com> 10.35.64-3mdv2010.0
+ Revision: 416591
- fix build
- rebuilt against libjpeg v7

* Sat Jun 27 2009 Oden Eriksson <oeriksson@mandriva.com> 10.35.64-1mdv2010.0
+ Revision: 389813
- sync with netpbm-10.35.64-1.fc12.src.rpm
- rediffed one patch

* Wed May 06 2009 Oden Eriksson <oeriksson@mandriva.com> 10.35.62-1mdv2010.0
+ Revision: 372602
- sync with netpbm-10.35.62-1.fc11.src.rpm

* Sun Feb 01 2009 Oden Eriksson <oeriksson@mandriva.com> 10.35.59-1mdv2009.1
+ Revision: 336021
- sync with netpbm-10.35.59-1.fc11.src.rpm

* Sat Jan 31 2009 Oden Eriksson <oeriksson@mandriva.com> 10.35.57-2mdv2009.1
+ Revision: 335844
- rebuilt against new jbigkit major

* Sat Dec 20 2008 Oden Eriksson <oeriksson@mandriva.com> 10.35.57-1mdv2009.1
+ Revision: 316456
- sync with netpbm-10.35.57-1.fc11.src.rpm
- fix build with -Werror=format-security (P21)
- use %%ldflags

* Mon Oct 27 2008 Oden Eriksson <oeriksson@mandriva.com> 10.35.53-1mdv2009.1
+ Revision: 297571
- sync with netpbm-10.35.53-1.fc10.src.rpm

* Sat Jul 12 2008 Oden Eriksson <oeriksson@mandriva.com> 10.35.46-1mdv2009.0
+ Revision: 234002
- sync (slightly) with netpbm-10.35.46-1.fc10.src.rpm
- fix deps
- fix a typo in P8

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Wed Nov 07 2007 Oden Eriksson <oeriksson@mandriva.com> 10.34-10mdv2008.1
+ Revision: 106741
- P16: security fix for CVE-2007-2721 (embedded libjasper)
- added P8 to link against system libs such as jbigkit and libjasper,
  that should render P16 obsolete, but keep it for reference.

* Mon Oct 15 2007 Funda Wang <fwang@mandriva.org> 10.34-9mdv2008.1
+ Revision: 98351
- fix requires of develname

* Mon Oct 01 2007 Oden Eriksson <oeriksson@mandriva.com> 10.34-8mdv2008.0
+ Revision: 94149
- rebuilt due to missing packages

* Wed Sep 19 2007 Guillaume Rousse <guillomovitch@mandriva.org> 10.34-7mdv2008.0
+ Revision: 90006
- rebuild

* Tue Sep 18 2007 Anssi Hannula <anssi@mandriva.org> 10.34-6mdv2008.0
+ Revision: 89729
- rebuild due to package loss

* Sun Sep 09 2007 Oden Eriksson <oeriksson@mandriva.com> 10.34-5mdv2008.0
+ Revision: 83516
- new devel naming


* Sun Oct 15 2006 Oden Eriksson <oeriksson@mandriva.com> 10.34-4mdv2007.0
+ Revision: 64864
- bzip2 cleanup
- rebuild
- bunzip patches
- Import netpbm

* Sun Jul 16 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 10.34-2
- add BuildRequires: libx11-devel libxml2-devel

* Fri Jul 14 2006 Stew Benedict <sbenedict@mandriva.com> 10.34-1mdv2007.0
- New release 10.34
- update P7(Red Hat security patch, name it 10.34 though)
- rediff P13(bmptopnm)
- drop P16(ppmtogif), P17(nstring), P18(pnmtofits overflow)
- add 3 more CR to the empty configure input

* Sat May 27 2006 Stew Benedict <sbenedict@mandriva.com> 10.33-2mdv2007.0
- P18: fix for #21444 (buffer overflow in pnmtofits)

* Tue May 09 2006 Stew Benedict <sbenedict@mandriva.com> 10.33-1mdk
- 10.33 
- drop commented P8,12; drop P2,9,15; update P13
- update P3,6,7; add P15,16,17 (from Fedora)

* Fri Nov 04 2005 Frederic Crozat <fcrozat@mandriva.com> 10.29-4mdk
- package now owns its share directories

* Wed Nov 02 2005 Olivier Blin <oblin@mandriva.com> 10.29-3mdk
- from Stew Benedict: security update for CAN-2005-2978 (P15, #19447)
  (diff against pnmtopng.c from 0.30)

* Wed Nov 02 2005 Abel Cheung <deaddog@mandriva.org> 10.29-2mdk
- Rebuild

* Sun Aug 21 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 10.29-1mdk
- 10.29
- sync with fedora:
	o fix segfault in bmptopnm caused by freeing an uninitialized pointer (P13)
	o update .CAN-2005-2471 patch (P14)
	o update P4, P6 & P7
- drop P8
- fix buildconflicts
- %%mkrel

* Sun Aug 14 2005 Stew Benedict <sbenedict@mandriva.com> 10.26-5mdk
- buildconflicts

* Sun Aug 14 2005 Stew Benedict <sbenedict@mandriva.com> 10.26-4mdk
- rebuild in a clean(er) environment without libsvgalib

* Sat Aug 13 2005 Olivier Blin <oblin@mandriva.com> 10.26-3mdk
- from Vincent Danen: security fix for pstopnm (Patch12)
- fix Patch7 for gcc4
- remove Requires on release

* Wed Feb 16 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 10.26-2mdk
- multiarch
- netpbm is very likely to depend on libm (pow, log), aka fix build of
  e.g. gocr with netpbm support on x86_64 and others without such builtins

* Thu Jan 13 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 10.26-1mdk
- 10.26
- update security patch (P7 from fedora)
- drop P9 (merged with P7) & P10 (merged upstream)

* Sat Dec 18 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 10.25-2mdk
- remove fix of path to perl in scripts (not needed anymore)

* Fri Dec 17 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 10.25-1mdk
- sync with fedora (about friggin' time!)
- cosmetics

